#! /usr/bin/env node

const fs = require('fs-extra');
const shell = require('shelljs');
const logSymbols = require('log-symbols');
const path = require('path');

const current = process.cwd();
const destination = process.argv.length > 2 ? path.join(current, process.argv[2]) : current;

const destinationExists = fs.existsSync(destination);
if (destinationExists && process.argv.length > 2) {
    console.warn(logSymbols.error, `Folder "${destination}" already exists. Aborting...`)
    process.exit(1);
}

console.log(logSymbols.info, 'Acquiring payload...');
fs.copy(path.join(__dirname, 'boilerplate'), destination, err => {
    if (err) {
      console.warn(err);
      process.exit(1);
      return;
    }
    console.log(logSymbols.success, 'Payload acquired!\n');
    console.log(logSymbols.info, 'Attaching boosters...\n');
    shell.cd(destination)
    shell.exec(`${isYarnAvailable() ? 'yarn' : 'npm i'}`)
    console.log('\n', logSymbols.success, 'Boosters attached!\n');
    console.log(logSymbols.success, 'Success! Your awesome next-express-bootstrap-boilerplate launched!\n');
    process.exit(0);
});

const isYarnAvailable = () => shell.exec('yarnpkg --version').code === 0;
